import java.awt.*;
import java.awt.image.*;
import javax.media.opengl.*;
import com.sun.opengl.util.*;
import com.sun.opengl.util.texture.*;
import javax.media.opengl.glu.*;
import java.nio.*;
import com.cycling74.max.*;

public class DIPSString extends MaxObject {
	GLContext glContext;
	GL gl;
	GLString glstr1;
	
	String str = "text";
	String font = "Arial";
	int size = 40;
	int align = 0;
	
	public DIPSString() {
	}
	public void notifyDeleted() {
    	System.gc();
    }
	
	public void text( Atom[] atoms ) {
		str = Atom.toOneString( atoms );
	}
	
	public void font( Atom[] atoms ) {
		font = Atom.toOneString( atoms );
	}
	
	public void size( int i ) {
		size = i;
	}
	
	public void align( Atom[] atoms ) {
		String command = Atom.toOneString( atoms );
		if ( command.equals( "left" ) ) {
			align = 0;
		} else if ( command.equals( "right" ) ) {
			align = 1;
		} else if ( command.equals( "center" ) ) {
			align = 2;
		}
	}
	
	boolean initialized = false;
	public void bang() {
		if ( !initialized ) {
			glContext = GLDrawableFactory.getFactory().createExternalGLContext();
			gl = glContext.getGL();
			glstr1 = new GLString(gl);
			initialized = true;
		}
		if ( gl != null ) {
			glContext.makeCurrent();
			glstr1.setAlign( align );
			glstr1.setFontSize( size );
			glstr1.setFontName( font );
			glstr1.draw( str );
			glContext.release();
		}
		outletBang( 0 );
	}

}

class GLString {
	int align = 0;	//0=left, 1=right, 2=center
	String fontName = "Times New Roman";
	int fontSize = 64;
	String str;

	int textureNumber;
	int width, height;
	BufferedImage img;
	boolean changed = false;

	public GLString(GL gl) {
		//final GL gl = GLContext.getCurrent().getGL();
		int[] tmp = new int[ 1 ];
		gl.glGenTextures( 1, tmp, 0 );
		textureNumber = tmp[ 0 ];
		gl.glBindTexture( GL.GL_TEXTURE_RECTANGLE_EXT, textureNumber );
	}

	public void setAlign( int n ) {
		if ( align != n ) changed = true;
		align = n;
	}

	public void setFontName( String s ) {
		if ( fontName != s ) changed = true;
		fontName = s;
	}

	public void setFontSize( int n ) {
		if ( fontSize != n ) changed = true;
		fontSize = n;
	}

	public void draw( String s ) {
		final GL gl = GLContext.getCurrent().getGL();
		if ( !s.equals( str ) ) changed = true;
		str = s;
		gl.glPushAttrib( GL.GL_ALL_ATTRIB_BITS );
		gl.glMatrixMode( GL.GL_TEXTURE );
		gl.glPushMatrix();
		gl.glLoadIdentity();
		gl.glMatrixMode( GL.GL_MODELVIEW );
		gl.glPushMatrix();
		gl.glBindTexture( GL.GL_TEXTURE_RECTANGLE_EXT, textureNumber );
		if ( changed && str != "" ) {
			img = new BufferedImage( 100, 100, BufferedImage.TYPE_INT_ARGB );
			Graphics g = img.createGraphics();
			g.setFont( new Font( fontName, Font.PLAIN, fontSize ) );
			width = g.getFontMetrics().stringWidth( s );
			height = g.getFontMetrics().getHeight();
			img = new BufferedImage(
				width,
				height,
				BufferedImage.TYPE_INT_ARGB
			);
			Graphics2D g2 = img.createGraphics();
			g2.setRenderingHint( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );
			g2.setColor( Color.white );
			g2.setFont( new Font( fontName, Font.PLAIN, fontSize ) );
			g2.drawString( s, 0, g.getFontMetrics().getHeight() - g.getFontMetrics().getDescent() );
			try {
				//javax.imageio.ImageIO.write( img, "png", new java.io.File( "a.png" ) );
			} catch ( Exception e ) {}
			
			ByteBuffer dest = null;
			int[] data = ((DataBufferInt) img.getRaster().getDataBuffer()).getData();
			dest = ByteBuffer.allocateDirect(data.length * BufferUtil.SIZEOF_INT);
			dest.order(ByteOrder.nativeOrder());
			dest.asIntBuffer().put(data, 0, data.length);
			gl.glTexImage2D( GL.GL_TEXTURE_RECTANGLE_EXT, 0, GL.GL_RGBA, img.getWidth(), img.getHeight(), 0, GL.GL_BGRA, GL.GL_UNSIGNED_BYTE, dest );
			gl.glTexParameteri( GL.GL_TEXTURE_RECTANGLE_EXT, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR );
			gl.glTexParameteri( GL.GL_TEXTURE_RECTANGLE_EXT, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
		}
		
		gl.glEnable( GL.GL_TEXTURE_RECTANGLE_EXT );
		switch( align ) {
			case 0:
				break;
			case 1:
				gl.glTranslatef( width * -1f, 0f, 0f );
				break;
			case 2:
				gl.glTranslatef( width * -0.5f, 0f, 0f );
				break;
		}
		
		gl.glEnable( GL.GL_BLEND );
		gl.glBlendFunc( GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA );
		gl.glBegin( GL.GL_QUADS );
		gl.glTexCoord2f( 0f, height );	gl.glVertex2f( 0f, 0f );
		gl.glTexCoord2f( width, height );	gl.glVertex2f( width, 0f );
		gl.glTexCoord2f( width, 0f );	gl.glVertex2f( width, height );
		gl.glTexCoord2f( 0f, 0f );	gl.glVertex2f( 0f, height );
		gl.glEnd();
		gl.glDisable( GL.GL_TEXTURE_RECTANGLE_EXT );
		gl.glMatrixMode( GL.GL_TEXTURE );
		gl.glPopMatrix();
		gl.glMatrixMode( GL.GL_MODELVIEW );
		gl.glPopMatrix();
		gl.glPopAttrib();
		changed = false;
	}
}